zth-final-frontend/src/main/java/hu/zth/comp/fin/AccountBean.java
package hu.zth.comp.fin;

import hu.zth.comp.fin.model.Account;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.ws.rs.core.Response;
import java.io.Serializable;
import java.util.List;

@Named
@RequestScoped
public class AccountBean implements Serializable {

    @Inject
    private BackendSessionBean backend;
    
    @Inject
    private IndexBean indexBean;

    public void topUp(Long accountId, Double amount) {
        Response topup = backend.getAccountService().topup(accountId, amount);
        if (topup.getStatus() == Response.Status.FORBIDDEN.getStatusCode()) {
            indexBean.setError("Operation forbidden, admin role is required");
        } else {
            indexBean.setInfo("Account topUp with ID " + accountId + " success with amount " + amount);
        }
        topup.close();
    }
    
    public List<Account> getAccounts() {
        return backend.getAccountService().getAccounts(backend.getUserService().getUser().getId());
    }
    
}

zth-final-frontend/src/main/java/hu/zth/comp/fin/BackendSessionBean.java
package hu.zth.comp.fin;

import hu.zth.comp.fin.api.AccountService;
import hu.zth.comp.fin.api.TransactionService;
import hu.zth.comp.fin.api.UserService;
import org.jboss.resteasy.client.jaxrs.ResteasyClient;
import org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder;
import org.jboss.resteasy.client.jaxrs.ResteasyWebTarget;

import javax.annotation.PostConstruct;
import javax.enterprise.context.SessionScoped;
import javax.ws.rs.core.UriBuilder;
import java.io.Serializable;

@SessionScoped
public class BackendSessionBean implements Serializable {

    private static final String BACKEND_BASE_URL = System.getProperty("zth.backend.url", "http://localhost:8000");
    
    private transient UserService userService;
    private transient AccountService accountService;
    private transient TransactionService transactionService;

    @PostConstruct
    private void init() {
        reinitRestClient();
    }
    
    public void reinitRestClient() {
        ResteasyClient client = new ResteasyClientBuilder().build();
        ResteasyWebTarget target = client.target(UriBuilder.fromPath(BACKEND_BASE_URL));
        userService = target.proxy(UserService.class);
        accountService = target.proxy(AccountService.class);
        transactionService = target.proxy(TransactionService.class);
    }

    public UserService getUserService() {
        return userService;
    }

    public AccountService getAccountService() {
        return accountService;
    }

    public TransactionService getTransactionService() {
        return transactionService;
    }
}

zth-final-frontend/src/main/java/hu/zth/comp/fin/IndexBean.java
package hu.zth.comp.fin;

import org.jboss.logging.Logger;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import java.io.Serializable;

@Named
@SessionScoped
public class IndexBean implements Serializable {
    
    private static final Logger log = Logger.getLogger(IndexBean.class);
    
    private String error;
    private String info;

    public String getErrorAndClear() {
        String errorMessage = this.error;
        this.error = null;
        return errorMessage;
    }

    public String getError() {
        return error;
    }
    
    public void setError(String error) {
        this.error = error;
    }

    public String getInfoAndClear() {
        String infoMessage = this.info;
        this.info = null;
        return infoMessage;
    }
    
    public String getInfo() {
        return info;
    }

    public void setInfo(String info) {
        this.info = info;
    }
    
    public void refresh() {
        log.debug("Refresh clicked");
    }
}

zth-final-frontend/src/main/java/hu/zth/comp/fin/LoginBean.java
package hu.zth.comp.fin;

import hu.zth.comp.fin.model.UserRole;

import javax.enterprise.context.SessionScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.ws.rs.NotAuthorizedException;
import javax.ws.rs.core.Response;
import java.io.IOException;
import java.io.Serializable;

@Named
@SessionScoped
public class LoginBean implements Serializable {
    
    public static final String LOGIN_XHTML = "/login.xhtml";
    public static final String INDEX_XHTML = "/index.xhtml";
    
    @Inject
    private BackendSessionBean backend;
    
    @Inject
    private IndexBean indexBean;
    
    private String error = null;
    private String loggedInUsername = null;

    public String getError() {
        return error;
    }

    public void setError(String error) {
        this.error = error;
    }

    public String getLoggedInUsername() {
        return loggedInUsername;
    }

    public void login(String username, String password) throws IOException {
        if (backend.getUserService().login(username, password).getStatus() == Response.Status.OK.getStatusCode()) {
            error = null;
            loggedInUsername = username;
            FacesContext.getCurrentInstance().getExternalContext().redirect(INDEX_XHTML);
        } else {
            error = "Wrong username or password";
            loggedInUsername = null;
        }
    }
    
    public void logout() throws IOException {
        if (backend.getUserService().logout().getStatus() == Response.Status.OK.getStatusCode()) {
            error = null;
            loggedInUsername = null;
            FacesContext.getCurrentInstance().getExternalContext().redirect(LOGIN_XHTML);
        } else {
            indexBean.setError("Could not log out");
        }
    }
    
    public String getRealName() throws IOException {
        try {
            return backend.getUserService().getUser().getRealname();
        } catch (NotAuthorizedException e) {
            error = "Session lost, login again";
            FacesContext.getCurrentInstance().getExternalContext().redirect(LOGIN_XHTML);
            return "";
        }
    }

    public boolean isAdmin() {
        return backend.getUserService().getUser().getRole() == UserRole.ADMIN;
    }
    
}

zth-final-frontend/src/main/java/hu/zth/comp/fin/TranactionBean.java
package hu.zth.comp.fin;

import hu.zth.comp.fin.model.Account;
import hu.zth.comp.fin.model.Transaction;
import hu.zth.comp.fin.model.TransactionStatus;

import javax.enterprise.context.RequestScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.Response;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Named
@RequestScoped
public class TranactionBean implements Serializable {

    @Inject
    private BackendSessionBean backend;

    @Inject
    private IndexBean indexBean;

    public List<Transaction> getLast10Transactions() {
        Long userId = backend.getUserService().getUser().getId();
        List<Account> accounts = backend.getAccountService().getAccounts(userId);
        List<Transaction> transactions = new ArrayList<>();
        accounts.forEach(account -> transactions.addAll(backend.getTransactionService().getLast10Transactions(account.getId())));
        transactions.sort((o1, o2) -> o2.getId().compareTo(o1.getId()));
        return transactions;
    }

    public void sendTransactionRequest(Long sourceAccountId, Long destinationAccountId, Double amount, String comment) {
        Response response = backend.getTransactionService().requestTransaction(sourceAccountId, destinationAccountId, amount, comment);
        if (response.getStatus() == Response.Status.OK.getStatusCode()) {
            indexBean.setInfo("Transaction request has been sent (" + sourceAccountId + " -> " + destinationAccountId + " with amount " + amount + "), comment: " + response.readEntity(String.class));
        } else {
            indexBean.setError("Transaction request error: " + response.readEntity(String.class));
        }
        response.close();
    }
    
    public boolean isPending(Transaction transaction) {
        return transaction.getStatus() == TransactionStatus.PENDING;
    }
    
    public void export(Account account) throws IOException {
        Response response = backend.getTransactionService().exportTransactions(account.getId());
        if (response.getStatus() == Response.Status.OK.getStatusCode()) {
            indexBean.setInfo("Exported account: " + account.getId());
            createDownload(response.readEntity(String.class), account.getId());
        } else {
            indexBean.setError("Export error: " + response.readEntity(String.class));
        }
        
        response.close();
    }
    
    private void createDownload(String exportedXml, Long accountId) throws IOException {
        FacesContext fc = FacesContext.getCurrentInstance();
        HttpServletResponse resp = (HttpServletResponse) fc.getExternalContext().getResponse();

        resp.setContentType("application/octet-stream");
        resp.addHeader("Content-Disposition", "attachment; filename=\"account-" + accountId + ".xml\"");

        PrintWriter writer = resp.getWriter();
        writer.append(exportedXml);

        writer.close();
        FacesContext.getCurrentInstance().responseComplete();
    }

}

zth-final-frontend/src/main/webapp/error.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
<h:head>
    <title>ERROR - ZTH-final</title>
    <style type="text/css">
        body {
            font-family: sans-serif;
            font-size: 16px;
            color: #404040;
        }

        .errorPanel {
            color: #A00000;
            background-color: #FFD0D0;
            border: 1px solid #FFA0A0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
            font-weight: bold;
        }

        input[type='submit'], input[type='button'] {
            height: 32px;
            font-weight: bold;
            background-color: #FAFAFA;
            border: 1px solid #F0F0F0;
            color: #707070;
            font-size: 16px;
        }

        input[type='submit']:hover, input[type='button']:hover {
            background-color: #F0F0F0;
            border: 1px solid #EAEAEA;
            color: #6A6A6A;
        }

        .redButton {
            background-color: #FFEAEA !important;
            border: 1px solid #FAD0D0 !important;
            color: #905050 !important;
        }

        .redButton:hover {
            background-color: #FAE0E0 !important;
            border: 1px solid #F0CACA !important;
            color: #854545 !important;
        }
        
        .customHr {
            border-top: 1px solid #F0F0F0;
            margin-top: 4px;
            margin-bottom: 4px;
        }

        .rightIt * {
            float: right;
        }

        .rightIt:after {
            content: '';
            display: block;
            clear: both;
        }
    </style>
</h:head>
<body>

<h:form>

    <h:button class="redButton" value="Home" outcome="/index.xhtml"/>
    
    <div class="customHr"></div>

    <div class="errorPanel">
        Exception: #{requestScope['javax.servlet.error.exception'].class.name} -> #{requestScope['javax.servlet.error.exception'].message}
    </div>

</h:form>

</body>
</html>

zth-final-frontend/src/main/webapp/index.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
<h:head>
    <title>ZTH-final</title>
    <style type="text/css">
        body {
            font-family: sans-serif;
            font-size: 16px;
            color: #404040;
        }

        .errorPanel {
            color: #A00000;
            background-color: #FFD0D0;
            border: 1px solid #FFA0A0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
            font-weight: bold;
        }

        .infoPanel {
            color: #00A000;
            background-color: #D0FFD0;
            border: 1px solid #A0FFA0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
            font-weight: bold;
        }

        input[type='text'], input[type='password'] {
            width: 100%;
            height: 32px;
            color: #101010;
            font-weight: bold;
            font-size: 16px;
        }

        input[type='submit'], input[type='button'] {
            height: 32px;
            font-weight: bold;
            background-color: #FAFAFA;
            border: 1px solid #F0F0F0;
            color: #707070;
            font-size: 16px;
        }

        input[type='submit']:hover, input[type='button']:hover {
            background-color: #F0F0F0;
            border: 1px solid #EAEAEA;
            color: #6A6A6A;
        }

        .redButton {
            background-color: #FFEAEA !important;
            border: 1px solid #FAD0D0 !important;
            color: #905050 !important;
        }

        .redButton:hover {
            background-color: #FAE0E0 !important;
            border: 1px solid #F0CACA !important;
            color: #854545 !important;
        }

        .taskForm {
            margin: 4px;
            border: 1px solid #F0F0F0;
            border-radius: 4px;
            background-color: #FCFCFC;
            padding: 18px;
            color: #505050;
        }

        .customHr {
            border-top: 1px solid #F0F0F0;
            margin-top: 4px;
            margin-bottom: 4px;
        }

        .rightIt * {
            float: right;
        }

        .rightIt:after {
            content: '';
            display: block;
            clear: both;
        }

        .accountsTable {
            border: 1px solid #C0C0C0;
            padding: 0;
            background-color: #FFFFFF;
            border-collapse: collapse;
            font-size: 18px;
            border-radius: 4px;
        }

        .accountsTable th {
            font-weight: bold;
            border-bottom: 2px solid #F0F0F0;
            background-color: #FAFAFA;
            padding: 8px;
        }

        .accountsTable td {
            border-bottom: 1px solid #E0E0E0;
            padding: 8px;
        }

        .accountsTable .rightCellWithLeftBorder {
            text-align: right;
            border-left: 1px solid #E0E0E0;
        }

        .accountsTable .leftCellWithLeftBorder {
            text-align: left;
            border-left: 1px solid #E0E0E0;
        }

        .accountsTable .centerCell {
            text-align: center;
        }

        .accountsTable .centerCellWithBothBorder {
            text-align: center;
            border-left: 1px solid #E0E0E0;
            border-right: 1px solid #E0E0E0;
        }

        .accountsTable .rightCell {
            text-align: right;
        }

    </style>
</h:head>
<body>

<h:panelGroup rendered="#{not empty indexBean.error}">
    <div class="errorPanel">
        <h:outputText value="#{indexBean.errorAndClear}"/>
    </div>
</h:panelGroup>

<h:panelGroup rendered="#{not empty indexBean.info}">
    <div class="infoPanel">
        <h:outputText value="#{indexBean.infoAndClear}"/>
    </div>
</h:panelGroup>

<h:form>
    <span style="margin-right: 32px; font-size: 18px">
        Welcome, <h:outputText value="#{loginBean.realName}" style="font-weight: bold"/><h:outputText value="(admin)"
                                                                                                      rendered="#{loginBean.admin}"/>!
    </span>
    <div class="rightIt" style="display: inline">
        <h:commandButton class="redButton" value="Logout" action="#{loginBean.logout()}"/>
        <h:commandButton value="Refresh" action="#{indexBean.refresh()}"/>
    </div>
    <div class="customHr" style="margin-bottom: 16px"/>

    <div class="taskForm">

        <div>
            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>Request transaction</h1>

                <div class="taskForm" style="width: 300px">
                    <h:outputLabel for="sourceAccId" value="Source account ID"/>
                    <h:inputText id="sourceAccId" binding="#{sourceAccId}"/>

                    <h:outputLabel for="destAccId" value="Destination account ID"/>
                    <h:inputText id="destAccId" binding="#{destAccId}"/>

                    <h:outputLabel for="transAmount" value="Amount"/>
                    <h:inputText id="transAmount" binding="#{transAmount}"/>

                    <h:outputLabel for="comment" value="Comment"/>
                    <h:inputText id="comment" binding="#{comment}"/>

                    <div class="customHr" style="margin-bottom: 16px"/>

                    <div class="rightIt">
                        <h:commandButton value="Send request"
                                         action="#{tranactionBean.sendTransactionRequest(sourceAccId.value, destAccId.value, transAmount.value, comment.value)}"/>
                    </div>
                </div>
            </div>
            
            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>TopUp (admin)</h1>

                <div class="taskForm" style="width: 300px">
                    <h:outputLabel for="topupAccountId" value="Account ID to topUp"/>
                    <h:inputText id="topupAccountId" binding="#{topupAccountId}"/>

                    <h:outputLabel for="topupAmount" value="Amount"/>
                    <h:inputText id="topupAmount" binding="#{topupAmount}"/>

                    <div class="customHr" style="margin-bottom: 16px"/>

                    <div class="rightIt">
                        <h:commandButton value="TopUp"
                                         action="#{accountBean.topUp(topupAccountId.value, topupAmount.value)}"/>
                    </div>
                </div>
            </div>

            <div style="float: left; display: inline; margin-right: 24px;">
                <h1>Accounts</h1>
                <table class="accountsTable">
                    <tr>
                        <th class="rightCell">AccID</th>
                        <th class="leftCellWithLeftBorder">Account name</th>
                        <th class="rightCellWithLeftBorder">Balance</th>
                        <th class="rightCellWithLeftBorder"></th>
                    </tr>
                    <ui:repeat value="#{accountBean.accounts}" var="account">
                        <tr>
                            <td style="min-width: 50px" class="rightCell"><h:outputText value="${account.id}"/></td>
                            <td style="min-width: 300px" class="leftCellWithLeftBorder"><h:outputText
                                    value="${account.name}"/></td>
                            <td style="min-width: 150px" class="rightCellWithLeftBorder"><h:outputText
                                    value="${account.balance}"/></td>
                            <td class="rightCellWithLeftBorder">
                                <h:commandButton value="Export" action="#{tranactionBean.export(account)}"/>
                            </td>
                        </tr>
                    </ui:repeat>
                </table>
            </div>
            
            <div style="clear: both"></div>
        </div>

        <h1>Transactions</h1>
        <table class="accountsTable">
            <tr>
                <th class="rightCell">TrID</th>
                <th class="rightCellWithLeftBorder">Amount</th>
                <th class="rightCellWithLeftBorder">Source account</th>
                <th></th>
                <th>Destination account</th>
                <th class="centerCellWithBothBorder">Status</th>
                <th class="centerCell">Request time</th>
                <th class="centerCell">Finish time</th>
                <th class="leftCellWithLeftBorder">Comment</th>
                <th class="leftCellWithLeftBorder">Error</th>
            </tr>

            <ui:repeat value="#{tranactionBean.last10Transactions}" var="trans">
                <tr>
                    <td style="min-width: 50px" class="rightCell"><h:outputText value="${trans.id}"/></td>
                    <td style="min-width: 100px" class="rightCellWithLeftBorder"><h:outputText value="${trans.amount}"/>
                    </td>
                    <td style="min-width: 100px" class="rightCellWithLeftBorder"><h:outputText
                            value="${trans.sourceAccount.name} [${trans.sourceAccount.id}]"/></td>
                    <td style="font-size: 32px">⟶</td>
                    <td style="min-width: 100px"><h:outputText
                            value="[${trans.destinationAccount.id}] ${trans.destinationAccount.name}"/></td>
                    <td style="min-width: 60px" class="centerCellWithBothBorder">
                        <h:outputText value="${trans.status.label()}" rendered="#{tranactionBean.isPending(trans)}"
                                      style="font-weight: bold; color: #AFA040"/>
                        <h:outputText value="${trans.status.label()}"
                                      rendered="#{not tranactionBean.isPending(trans)}"/>
                    </td>
                    <td style="font-size: 12px; min-width: 100px" class="centerCell"><h:outputText
                            value="#{trans.requested}">
                        <f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss"/>
                    </h:outputText></td>
                    <td style="font-size: 12px; min-width: 100px" class="centerCell"><h:outputText
                            value="#{trans.finished}">
                        <f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss"/>
                    </h:outputText></td>
                    <td style="font-size: 12px; font-style: italic; min-width: 100px" class="leftCellWithLeftBorder">
                        <h:outputText value="${trans.comment}"/></td>
                    <td style="font-size: 12px; color: #A00000; font-weight: bold; min-width: 200px"
                        class="leftCellWithLeftBorder"><h:outputText value="${trans.errorMessage}"/></td>
                </tr>
            </ui:repeat>
        </table>
        
    </div>
</h:form>

</body>
</html>

zth-final-frontend/src/main/webapp/login.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:a="http://xmlns.jcp.org/jsf/passthrough">
<h:head>
    <title>Login - ZTH-final</title>
    
    <style type="text/css">
        body {
            font-family: sans-serif;
            font-size: 16px;
        }
        
        .loginForm {
            margin-top: 100px;
            margin-left: auto;
            margin-right: auto;
            width: 300px;
            border: 1px solid #F0F0F0;
            border-radius: 4px;
            background-color: #FCFCFC;
            padding: 24px;
            color: #505050;
        }
        
        input[type='text'], input[type='password'] {
            width: 100%;
            height: 32px;
            color: #101010;
            font-weight: bold;
            font-size: 22px;
            margin-bottom: 16px;
        }
        
        input[type='submit'] {
            width: 100px;
            height: 32px;
            font-weight: bold;
            background-color: #D0FFD0;
            border: 1px solid #A0CCA0;
            color: #308030;
            font-size: 16px;
        }

        input[type='submit']:hover {
            background-color: #C0EFC0;
        }
        
        .error {
            color: #A00000;
            background-color: #FFD0D0;
            border: 1px solid #FFA0A0;
            border-radius: 4px;
            text-align: center;
            padding: 8px;
            margin: 8px 8px 24px;
        }

        .rightIt * {
            float: right;
        }

        .rightIt:after {
            content: '';
            display: block;
            clear: both;
        }
        
        .customHr {
            border-top: 1px solid #F0F0F0;
            margin-top: 4px;
            margin-bottom: 4px;
        }
    </style>
</h:head>
<body>

<div class="loginForm">
    <h2 style="margin-top: 8px;">Login</h2>
    
    <h:form>
        <h:panelGroup rendered="#{not empty loginBean.error}">
            <div class="error">
                <h:outputText value="#{loginBean.error}"/>
            </div>
        </h:panelGroup>
        
        <h:outputLabel for="username" value="Username:"/>
        <h:inputText id="username" binding="#{userInp}" a:autofocus="#{empty userInp.value ? true : null}"/>
        
        <h:outputLabel for="password" value="Password:"/>
        <h:inputSecret id="password" binding="#{passInp}" a:autofocus="#{empty userInp.value ? null : true}"/>
        
        <div class="customHr"/>
        <div class="rightIt">
            <h:commandButton value="Login" action="#{loginBean.login(userInp.value, passInp.value)}"/>
        </div>
    </h:form>
</div>

</body>
</html>